# This file is part of FatxFast.                                                
#                                                                               
#    FatxFast is free software: you can redistribute it and/or modify           
#    it under the terms of the GNU General Public License as published by       
#    the Free Software Foundation, either version 3 of the License, or          
#    (at your option) any later version.                                        
#                                                                               
#    FatxFast is distributed in the hope that it will be useful,                
#    but WITHOUT ANY WARRANTY; without even the implied warranty of             
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              
#    GNU General Public License for more details.                               
#                                                                               
#    You should have received a copy of the GNU General Public License          
#    along with FatxFast.  If not, see <http://www.gnu.org/licenses/>.          
                                                                                
# Versioning based on:                                                          
# http://en.wikipedia.org/wiki/Versioning#Designating_development_stage         
__author__ = "dryatu (c) 2013"                                                  
__version__ = "1.2.5" 
from FatxFast.gui.hud.frame import Frame
from FatxFast.gui.hud.minimapframe import MiniMapFrame
import datetime
import time

class GlobalHud(Frame):
    # Unified objects like time &  level
    def __init__(self, game, **kwargs):
        super(GlobalHud, self).__init__(game, **kwargs)
        self._cache_time = 0
        self._cache_level = 0 
        self.create_text(
            {"name": "clock-icon",
                "x": 70,
                "y": 5,
                "size": 24,
                "container": self,
                "text": u"\ue803",
                "font": "fontello.ttf"})
        self._time_widget = self.create_text(
            {
                "font":"lavoir.ttf",
                "name":"time",
                "x": 100,
                "y": 5,
                "text":"00:00:00",
                "container":self
            })
        self._level_widget = self.create_text({"name":"level",
            "x":770,
            "y": 5,
            "text":"LEVEL: 0",
            "font":"lavoir.ttf",
            "container":self})

    def update(self, dt):
        super(GlobalHud, self).update(dt)
        if self._cache_time != self.game.time/1000 and self.game.time > -1:
            self._cache_time = self.game.time/1000
            time_text = datetime.timedelta(seconds=self._cache_time)
            time_text = time.strftime("%H:%M:%S", time.strptime(str(time_text), 
                "%H:%M:%S"))
            self._time_widget.text = "%s" % time_text
            
        if self._cache_level != self.game.levelsystem.level:
            self._cache_level = self.game.levelsystem.level
            self._level_widget.text= "LEVEL: {0}".format(
                self.game.levelsystem.level)
        

